# FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
# License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
# Author: Sergey Cheremukhin
###############################################################################
# Find Flann
#
# This sets the following variables:
# FLANN_FOUND - True if FLANN was found.
# FLANN_INCLUDE_DIRS - Directories containing the FLANN include files.
# FLANN_LIBRARIES - Libraries needed to use FLANN.
# FLANN_DEFINITIONS - Compiler flags for FLANN.

find_path(FLANN_INCLUDE_DIR flann/flann.hpp
	HINTS /usr/include/ /usr/local/include/)

find_library(FLANN_LIBRARY flann
	HINTS /usr/lib /usr/lib32 /usr/lib64 /usr/local/lib /usr/local/lib32 /usr/local/lib64)

set(FLANN_INCLUDE_DIRS ${FLANN_INCLUDE_DIR})
set(FLANN_LIBRARIES ${FLANN_LIBRARY})

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(Flann DEFAULT_MSG
    FLANN_LIBRARY FLANN_INCLUDE_DIR)

mark_as_advanced(FLANN_LIBRARY FLANN_INCLUDE_DIR)

