# FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
# License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
# Author: Klaus Haeming

###############################################################################
# Find NETLIB
#
# This sets the following variables:
# NETLIB_FOUND - True if FLANN was found.
# NETLIB_INCLUDE_DIR - Directories containing the FLANN include files.

set(NETLIB_FILE_PATH ${PROJECT_SOURCE_DIR}/../thirdparty/netlib)
set(NETLIB_FILE "f2c.h")
find_path(NETLIB_INCLUDE_DIR NAMES ${NETLIB_FILE} PATHS ${NETLIB_FILE_PATH})
find_file(HAS_CLAPACK "clapack.h" ${NETLIB_FILE_PATH} )
find_file(HAS_RPOLY "rpoly.cpp" ${NETLIB_FILE_PATH} )

message(STATUS "Found NETLIB? " ${NETLIB_INCLUDE_DIR})
message(STATUS "NETLIB_FILE? " ${NETLIB_FILE})
message(STATUS "clapack: " ${HAS_CLAPACK})
message(STATUS "rpoly: " ${HAS_RPOLY})

set(NETLIB_FOUND "NO")

if(NETLIB_INCLUDE_DIR AND HAS_CLAPACK AND HAS_RPOLY)
	set(NETLIB_FOUND "YES")
	if(NOT NETLIB_FIND_QUIETLY)
		message(STATUS "Found NETLIB files: " ${NETLIB_INCLUDE_DIR})
	endif(NOT NETLIB_FIND_QUIETLY)
else(NETLIB_INCLUDE_DIR AND HAS_CLAPACK AND HAS_RPOLY)
	execute_process( COMMAND sh getnetlib.sh WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/../thirdparty)
	find_path(NETLIB_INCLUDE_DIR ${NETLIB_FILE} ${NETLIB_FILE_PATH})
	if(NETLIB_INCLUDE_DIR)
	        set(NETLIB_FOUND "YES")
	        if(NOT NETLIB_FIND_QUIETLY)
	                message(STATUS "Found NETLIB: " ${NETLIB_INCLUDE_DIR})
	        endif(NOT NETLIB_FIND_QUIETLY)
	endif( NETLIB_INCLUDE_DIR )
endif( NETLIB_INCLUDE_DIR AND HAS_CLAPACK AND HAS_RPOLY)

message(STATUS "Found NETLIB? " ${NETLIB_FOUND})

mark_as_advanced(NETLIB_INCLUDE_DIR)
mark_as_advanced(NETLIB_FOUND)

