

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_IMGPROCESSINGKERNELGAUSS_3_1_H
#define ADORE_IMGPROCESSINGKERNELGAUSS_3_1_H

#include <cassert>
#include <adrcore/types/commontypes.h>

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		template<class imgT>
		class KernelGauss_3_1
		{
			public:

				typedef imgT img_in_type;
				typedef imgT img_out_type;

				imgT convolveBorder( const imgT a, const imgT b ) const
				{
					return convolve( a, b, b );
				}

				imgT convolve( const imgT a, const imgT b, const imgT c ) const
				{
					assert( false );
				}
			private:
				int convolveInt( const int a, const int b, const int c ) const
				{
					return ( a + ( b << 1 ) + c ) >> 2;
				}
		};

		template<>
		inline uint8_t KernelGauss_3_1<uint8_t>::convolve( const uint8_t a, const uint8_t b, const uint8_t c ) const
		{
			return uint8_t( convolveInt( a, b, c ) );
		}

		template<>
		inline short KernelGauss_3_1<short>::convolve( const short a, const short b, const short c ) const
		{
			return short( convolveInt( a, b, c ) );
		}

	}
}

#endif
