

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_IMGPROCESSINGKERNELOPERATORBASE_H
#define ADORE_IMGPROCESSINGKERNELOPERATORBASE_H

namespace adore
{

	namespace core
	{

		/**
		 
		*/

		class KernelOperatorBase
		{
			public:

				KernelOperatorBase()
				{
				}

				virtual ~KernelOperatorBase()
				{
					;
				}

				uint getLeftHood() const
				{
					return leftHood;
				}

				uint getRightHood() const
				{
					return rightHood;
				}

				uint getTopHood() const
				{
					return topHood;
				}

				uint getBottomHood() const
				{
					return bottomHood;
				}

			protected:

				void setLeftHood( const uint h )
				{
					leftHood = h;
				}

				void setRightHood( const uint h )
				{
					rightHood = h;
				}

				void setTopHood( const uint h )
				{
					topHood = h;
				}

				void setBottomHood( const uint h )
				{
					bottomHood = h;
				}

			private:

				uint leftHood, rightHood, topHood, bottomHood;
		};


	}

}

#endif
