

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_IMGPROCESSINGKERNELPREWITT_3_1_H
#define ADORE_IMGPROCESSINGKERNELPREWITT_3_1_H

#include <cassert>
#include <adrcore/util/calctype.h>

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		template<class imgT>
		class KernelPrewitt_3_1
		{
			public:

				typedef imgT img_in_type;
				typedef typename signedT<typename imgCalcT<img_in_type>::type>::type img_out_type;

				img_out_type convolve( const imgT a, const imgT b ) const
				{
					img_out_type result = img_out_type( b ) - img_out_type( a );
//					if ( result != 0 ) printf( "%d = %d - %d\n", result, b, a );
					return result;
				}
		};

	}
}

#endif
