

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_NVIEWCAMERAMINFUNC_H
#define ADORE_NVIEWCAMERAMINFUNC_H

#include <vector>
#include <adrcore/types/aarray.h>

namespace adore
{
	namespace core
	{

		using namespace std;

		/**
		 * Used internally.
		 *  
		*/
		class CameraMinFunc
		{
			public:
				typedef double T_numtype;

			public:
				/**
				 * Constructor.
				 */
				CameraMinFunc();

				/**
				 * Destructor.
				 */
				~CameraMinFunc();

				/**
				 */
				void operator()( const AVector &camera, AVector& diff ) const;

				void set3DPoints( const vector<AVector*> *p3D )
				{
					pts3D = p3D;
				}

			protected:

                                const vector<AVector*> *pts3D;
		};

	}

}

#endif
