

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ADORE_PARAMETERIZATION_QUATERNION_H
#define ADORE_PARAMETERIZATION_QUATERNION_H

#include <adrcore/types/aarray.h>

namespace adore
{
	namespace core
	{
		/**
		 *	 
		 */
		class Quaternion : public AVector
		{
			public:
				Quaternion();
				void fromAngleAxis( double rad, double x, double y, double z );
				void fromRotationMatrix( const AMatrix& rotmat );
				AMatrix toRotationMatrix();
				void toRotationMatrix(AMatrix& mat);
				const Quaternion& operator*( const Quaternion& q );
		};
	}
}

#endif	// ADORE_PARAMETERIZATION_QUATERNION_H
