

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ADORE_PARAMETERIZATIONSIMPLE3DPOINTPARAM_H
#define ADORE_PARAMETERIZATIONSIMPLE3DPOINTPARAM_H

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		class Simple3DPointParam
		{
			public:
				Simple3DPointParam()
				{
					;
				}

				~Simple3DPointParam()
				{
					;
				}

				int getSize()
				{
					return 3;
				}

                void fromParam( const vector<AVector> &param, vector<AVector3D*> &pts ) const
				{
					for ( uint i = 0; i < param.size(); ++i )
					{
                        fromParam( param[i], *pts[i] );
					}
				}

                void toParam( const vector<AVector3D*> &pts, vector<AVector> &param ) const
				{
					assert( pts.size() >= param.size() );

					for ( uint i = 0; i < param.size(); ++i )
					{
                        toParam( *pts[i], param[i] );
					}
				}

				void fromParam( const AVector &param, AVector3D &pts ) const
				{
					pts( 0 ) = param( 0 );
					pts( 1 ) = param( 1 );
					pts( 2 ) = param( 2 );
					pts( 3 ) = 1.0;
				}

				void toParam( const AVector3D &pts, AVector &param ) const
				{
					double w = pts( 3 );
					assert_msg( w != 0.0, "point was (%f, %f, %f, %f)\n", pts( 0 ), pts( 1 ), pts( 2 ), pts( 3 ) );
					param( 0 ) = pts( 0 ) / w;
					param( 1 ) = pts( 1 ) / w;
					param( 2 ) = pts( 2 ) / w;
				}


		};

	}

}

#endif
