

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef PERSISTENCE_BOOST_FEATUREDESCRIPTOR_H
#define PERSISTENCE_BOOST_FEATUREDESCRIPTOR_H

#include <adrcore/persistence/boost/aarray.h>

#include <adrcore/types/featuredescriptor.h>

namespace boost
{
	namespace serialization
	{
		using namespace adore::core;

		template<typename Archive>
		void save( Archive & ar, const FeatureDescriptor& t, unsigned int version )
		{
			uint count = t.size(); ar & count;
			for ( uint i = 0; i < count; ++i )
			{
				const FeatureDescriptor::DescVecT& vec = t[i];
				ar << vec;
			}
		}

		template<typename Archive>
		void load( Archive & ar, FeatureDescriptor& t, unsigned int version )
		{
			uint count; ar & count;
			for ( uint i = 0; i < count; ++i )
			{
				FeatureDescriptor::DescVecT vec; ar >> vec;
				uint vsz = vec.size();
				t.addVector( vsz ) = vec;
			}
		}

		template<typename Archive>
		inline void serialize( Archive & ar, FeatureDescriptor& t, const unsigned int file_version )
		{
			split_free( ar, t, file_version );
		}
	}
}

#endif // PERSISTENCE_BOOST_FEATUREDESCRIPTOR_H
