

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ZOUTBUF_H
#define ZOUTBUF_H

#include <streambuf>
#include <cstdio>

namespace zstream
{

	using namespace std;

	class zoutbuf : public streambuf
	{
		public:
			zoutbuf();
			virtual ~zoutbuf();

			void open( const char* name );
			bool is_open()const;
			zoutbuf* close();

		protected:
			virtual int overflow( int c = EOF );
			virtual int sync();
			virtual streamsize xsputn( const char* s, streamsize n );

		private:
			enum { buf_size = 32768, data_window = 32768*128 };
			char buffer[buf_size];

			int lastError;
			void* file;
//			int flushCounter;

			void flushBuffer();
	};

} //zstream

#endif // ZOUTBUF_H
