

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_UTILCALCTYPE_H
#define ADORE_UTILCALCTYPE_H

#include "debug.h"
#include <adrcore/types/commontypes.h>

namespace adore
{

	namespace core
	{

		template <class T> struct calcT
		{
			typedef T type;
		};

		template <> struct calcT <uint8_t>
		{
			typedef uint32_t type;
		};

		template <> struct calcT <int8_t>
		{
			typedef int32_t type;
		};

		template <> struct calcT <uint16_t>
		{
			typedef uint32_t type;
		};

		template <> struct calcT <int16_t>
		{
			typedef int32_t type;
		};

		/////////////////////////////////////

		template <class T> struct signedT
		{
			typedef T type;
		};

		template <> struct signedT <uint8_t>
		{
			typedef int8_t type;
		};

		template <> struct signedT <uint16_t>
		{
			typedef int16_t type;
		};

		template <> struct signedT <uint32_t>
		{
			typedef int32_t type;
		};

		template <> struct signedT <adr_uint64>
		{
			typedef adr_int64 type;
		};

		//////////////////////////////////////

		//signed calc
		template <class T> struct sCalcT
		{
			typedef typename signedT<typename calcT<T>::type>::type type;
		};

		//////////////////////////////////////

		template <class T> struct unsignedT
		{
			typedef T type;
		};

		template <> struct unsignedT <int8_t>
		{
			typedef uint8_t type;
		};

		template <> struct unsignedT <int16_t>
		{
			typedef uint16_t type;
		};

		template <> struct unsignedT <int32_t>
		{
			typedef uint32_t type;
		};

		template <> struct unsignedT <adr_int64>
		{
			typedef adr_uint64 type;
		};

		///////////////// for images /////////////////

		template <class T> struct imgCalcT
		{
			typedef T type;
		};

		template <> struct imgCalcT <uint8_t>
		{
			typedef uint16_t type;
		};

		template <> struct imgCalcT <int8_t>
		{
			typedef int16_t type;
		};

		template <> struct imgCalcT <uint16_t>
		{
			typedef uint32_t type;
		};

		template <> struct imgCalcT <int16_t>
		{
			typedef int32_t type;
		};

		/////////////// print type /////////////////
		template<class T> void printType() {printf( "unknown type\n" );}
		template<> inline void printType<uint8_t>() {printf( "type is uint8_t\n" );}
		template<> inline void printType<uint16_t>() {printf( "type is uint16_t\n" );}
		template<> inline void printType<int8_t>() {printf( "type is int8_t\n" );}
		template<> inline void printType<int16_t>() {printf( "type is int16_t\n" );}
		template<> inline void printType<uint32_t>() {printf( "type is uint\n" );}
		template<> inline void printType<int32_t>() {printf( "type is int\n" );}
	}
}

#endif
