

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_LAPACKUTIL
#define ADORE_LAPACKUTIL

namespace adore
{
	namespace core
	{


		template<class IteratorIn, class IteratorOut>
		void rowToColumnMajor( IteratorIn in, IteratorOut dest, int numRows, int numCols )
		{
			for ( int i = 0; i < numRows; ++i, ++dest )
			{
				IteratorOut dCol = dest;
				for ( int col = 0; col < numCols; ++col, dCol += numRows, ++in )
				{
					*dCol = *in;
				}
			}

		}

		//this is for in is random access iterator
		template<class IteratorIn, class IteratorOut>
		void columnToRowMajor( IteratorIn in, IteratorOut dest, int numRows, int numCols )
		{
			for ( int i = 0; i < numRows; ++i, ++in )
			{
				IteratorIn inCol = in;
				for ( int col = 0; col < numCols; ++col, inCol += numRows, ++dest )
				{
					*dest = *inCol;
				}
			}

		}



	}
}

#endif
