

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORESTORAGEORDER_H
#define ADORESTORAGEORDER_H

#include <adrcore/types/aarray.h>
#include <adrcore/util/debug.h>

namespace adore
{
	namespace core
	{

		template<class T_numtype>
		inline void checkStorageOrder( const AArray<T_numtype, 2> &mat )
		{
#ifndef NDEBUG
#ifndef COLUMNMAJOR

			using namespace std;
			const T_numtype *d = mat.data();
			int i = 0;
			for ( unsigned row = 0; row < mat.rows(); ++row )
			{
				for ( unsigned col = 0; col < mat.cols(); ++col, ++i )
				{
					if ( mat( row, col ) != d[i] )
					{
						cout << mat << endl;
						assert( mat( row, col ) == d[i] );
					}
				}
			}
#else
			const T_numtype *d = mat.data();
			int i = 0;
			for ( int col = 0; col < mat.cols(); ++col )
			{
				for ( int row = 0; row < mat.rows(); ++row, ++i )
				{
					assert( mat( row, col ) == d[i] );
				}
			}
#endif
#else
			ADORE_UNUSED( mat );
#endif
		}

		template<class T_numtype>
		inline void checkStorageOrder( const AArray<T_numtype, 1> &mat )
		{
#ifndef NDEBUG
			const T_numtype *d = mat.data();
			int i = 0;
                        for ( unsigned row = 0; row < mat.rows(); ++row, ++i )
			{
				assert( mat( row ) == d[i] );
			}
#else
			ADORE_UNUSED( mat );
#endif
		}

	}
}

#endif
