

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_COREARRANGINGVIEWRELATER_H
#define ADORE_COREARRANGINGVIEWRELATER_H

#include <adrcore/imgprocessing/imagearranger.h>
#include "viewrelater.h"
namespace adore
{

	namespace core
	{

		/**
			 
		*/
		class ArrangingViewRelater : public ViewRelater
		{
			private:
				int featsId;
				int descrId;
				ImageArranger iarranger;

			public:
				ArrangingViewRelater ( int fId = 0, int dId = 0 ) :featsId ( fId ), descrId ( dId ) {}

				void createRelations ( ViewBase **vit, int numViews, ViewRelations &vrela )
				{
					ImageArranger::AdMatrix adj = iarranger.arrange ( vit, numViews, featsId, descrId );
					for ( int i = 0; i < numViews; ++i, ++vit )
					{
						/*uint idx = */
						vrela.addView( *vit );
						//printf("relate %p -> %d\n", *vit, idx);
					}
					vrela.adoptNeighbors( adj );
				}
		};

	}

}

#endif
