

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "display.h"

namespace adore {
namespace visual {

    Display *Display::globalDisplay(NULL);
    
    void display_drawScene()
{
    printf("numClients: %d\n", Display::getGlobalDisplay()->getNumClients());
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    for_each(Display::getGlobalDisplay()->getBegin(), 
             Display::getGlobalDisplay()->getEnd(), std::mem_fun(&DisplayClient::drawScene));
    glutSwapBuffers();
}

void display_idleFunc()
{
    for_each(Display::getGlobalDisplay()->getBegin(), 
             Display::getGlobalDisplay()->getEnd(), std::mem_fun(&DisplayClient::idleFunc));
}

void display_keyPressed(unsigned char key, int x, int y) 
{
    usleep(100);

    if (key == ESCAPE) 
    { 
        glutDestroyWindow(Display::getGlobalDisplay()->getWindow()); 
    }
    
    for(Display::Iterator it = Display::getGlobalDisplay()->getBegin(); 
        it != Display::getGlobalDisplay()->getEnd(); ++it)
    {
        (*it)->keyPressed(key, x, y);
    }
}

void display_reshapeFunc(int w, int h)
{
    if (h==0)
    h=1;

    glViewport(0, 0, w, h);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    gluPerspective(45.0f,(GLfloat)w/(GLfloat)h,0.1f,100.0f);
    glMatrixMode(GL_MODELVIEW);
}



}}

