

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Andrei Tchouev


#ifndef ADORE_GLMATERIAL_H
#define ADORE_GLMATERIAL_H

#include <string>

#include "glmath.h"

namespace adore
{
	namespace visual
	{
		/**	Contains render states for visualizing object materials
		 *
		 *	 
		 */
		class GLMaterial
		{
		public:
			std::string name;		///< name of the material
			bool smooth;			///< object is smooth shaded
			bool wireframe;			///< object is rendered in wireframe mode
			bool depth;				///< depth buffer enabled
			bool cull;				///< backface culling enabled

			Vector4D ambient;		///< ambient color
			Vector4D diffuse;		///< diffuse color
			Vector4D specular;		///< specular color
			float shininess;		///< shininess

			GLMaterial();

			/**	Set OpenGL material properties
			 */
			void setOpenGLMaterial();
		};
	}
}

#endif	// ADORE_GLMATERIAL_H
