

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Andrei Tchouev


#ifndef ADORE_GLRGBA_H
#define ADORE_GLRGBA_H

namespace adore
{
	namespace visual
	{
		class RGBA
		{
		public:
			unsigned char red;			///< red color component
			unsigned char green;		///< green color component
			unsigned char blue;			///< blue color component
			unsigned char alpha;		///< alpha color component

			RGBA();
			RGBA(unsigned char r, unsigned char g, unsigned char b);
			RGBA(unsigned char r, unsigned char g, unsigned char b, unsigned char a);
		};

		inline RGBA::RGBA()
		{
		}

		inline RGBA::RGBA(unsigned char r, unsigned char g, unsigned char b)
			:red(r),green(g),blue(b),alpha(0xff)
		{
		}

		inline RGBA::RGBA(unsigned char r, unsigned char g, unsigned char b, unsigned char a)
			:red(r),green(g),blue(b),alpha(a)
		{
		}

		inline bool operator==(const RGBA& lv, const RGBA& rv)
		{
			return (lv.red == rv.red &&
				lv.green == rv.green &&
				lv.blue == rv.blue &&
				lv.alpha == rv.alpha );
		}

		inline bool operator!=(const RGBA& lv, const RGBA& rv)
		{
			return (lv.red != rv.red ||
				lv.green != rv.green ||
				lv.blue != rv.blue ||
				lv.alpha != rv.alpha );
		}
	}
}

#endif	// ADORE_GLRGBA_H
