

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_OPENGLRENDERVIEWGRAPH_H
#define ADORE_OPENGLRENDERVIEWGRAPH_H

#include "renderitem.h"
#include <adrcore/types/viewgraph.h>

namespace adore {
namespace visual {

            using namespace adore::core;

/**
	 
*/
class RenderViewgraph : public RenderItem
{
    class glLink
    {
        public:
            float r, g, b, a;
            float x1, y1, z1;
            float x2, y2, z2;
            float weight;
    };

public:
    RenderViewgraph();

    ~RenderViewgraph();
    
    void render();
        
    void renderSelect(GLuint lastId);

    void attach(ViewGraph *vg);
    
    void setDisplayLines(bool d)
    {
        displayLines = d;
    }
        
    private:
        
        bool displayLines;
        vector<glLink> links;
};

}}

#endif
