

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef CONFIG_H
#define CONFIG_H

#include <string>
#include <vector>

#include "configparser.h"

namespace batch
{

	class Config
	{
		public:
			Config( const std::string& text = std::string() );
			void setText( const std::string& text );

			int getCmdCount()const { return program.cmds.size(); }
			const std::string& getCmd( uint idx )const;
			const std::string& getAlgorithm( uint idx )const;

			bool getOptionInt( uint idx, const std::string& opt, int& retval, uint v_idx = 0 )const;
			bool getOptionDouble( uint idx, const std::string& opt, double& retval, uint v_idx = 0 )const;
			bool getOptionStr( uint idx, const std::string& opt, std::string& retval, uint v_idx = 0 )const;
			bool getOptionBool( uint idx, const std::string& opt, bool& retval, uint v_idx = 0 )const;

		private:
			batch::_cfg_ program;

			bool checkCmdIdx( uint idx )const;
			enum WHAT { ALG, OPT, ERR };
			int optIdx( uint idx, const std::string& opt )const;
			WHAT checkOpt( uint idx, uint o_idx, uint v_idx, const std::string& opt )const;
	};

};// namespace batch

#endif

