

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#include "configconstants.h"

static const char * const Keywords[] =
{
	"CreateViewRelations", "MakePairs",
	"CalcFeatures", "FindLines", "CalcDescriptors",
	"CalcCorrs",
	"Track",

	"Normalize", "Denormalize", "Filter", "FilterAndMergeLines",
	"CalcTensor", "ProjectiveReconstruction",
	"MetricReconstruction","DefaultReconstruction",
	"GlobalAdjustment",

        "Harris", "Canny", "DOG", "Scale", "SURF",

        "Sift", "SurfD",

	"SequenceKnitter", "ArrangingKnitter",

        "KDTree", "MatchLines", "Flann",

	"KLTTracker",

	"FeatureID", "MaxPoints", "Hood", "MinDist",
        "MinStrength", "MinFraction", "Smooths",
        "Images", "HarrisThresh",
	"DescriptorID",

        "Mode",
	"SingleBest", "RatioBest", "BBFRatioBest",
        "Distthresh", "Threshold", "GoodRatio",


	"FocalLegth", "AspectRatio", "Skew", "PrincipalPointX",
	"PrincipalPointY",
	"Free", "FreeConst", "Soft", "SoftConst", "Hard", "HardConst",
	"Rotation", "Angle_Axis", "Location", "Z",
	"FL", "AR", "SKEW", "PPX", "PPY",

	"Descriptorcreator", "None"

};

batch::Keyword batch::strToEnum( const std::string & str )
{
	for ( int i = 0; i < batch::dummy_k; ++i )
	{
		if ( std::string( Keywords[i] ) == str )
			return batch::Keyword( i );
	}
	return batch::dummy_k;
}



const char * const allinone =

        "<command> <name>CreateViewRelations</name>"
        "<algorithm> <name>SequenceRelater</name> </algorithm>"
        "<algorithm> <name>ArrangingRelater</name> </algorithm>"
        "</command>"

        "<command> <name>MakePairs</name>"
        "</command>"

        "<command> <name>CalcFeatures</name>"
        "<algorithm> <name>Harris</name>"
        "<option>"
        "<type>int</type> <name>Hood</name> <value>5</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinDist</name> <value>3</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MinStrength</name> <value>50</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinFraction</name> <value>0.001</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MaxPoints</name> <value>1000</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>Descriptorcreator</name> <value>None</value>"
        "</option>"
        "</algorithm>"
        "<algorithm> <name>Canny</name>"
        "<option>"
        "<type>int</type> <name>Hood</name> <value>3</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinDist</name> <value>5.0</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MinStrength</name> <value>1000</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinFraction</name> <value>0.002</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MaxPoints</name> <value>1000</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>Descriptorcreator</name> <value>None</value>"
        "</option>"
        "</algorithm>"
        "<algorithm> <name>DOG</name>"
        "<option>"
        "<type>int</type> <name>Smooths</name> <value>3</value>"
        "</option>" "<option>"
        "<type>int</type> <name>Images</name> <value>3</value>"
        "</option>" "<option>"
        "<type>int</type> <name>HarrisThresh</name> <value>200</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>Descriptorcreator</name> <value>None</value>"
        "</option>"
        "</algorithm>"
        "<algorithm> <name>Scale</name>"
        "<option>"
        "<type>int</type> <name>Smooths</name> <value>4</value>"
        "</option>" "<option>"
        "<type>int</type> <name>Images</name> <value>8</value>"
        "</option>" "<option>"
        "<type>int</type> <name>HarrisThresh</name> <value>10000</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinDist</name> <value>3</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinFraction</name> <value>0.0000001</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MaxPoints</name> <value>5000</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>Descriptorcreator</name> <value>None</value>"
        "</option>"
        "</algorithm>"
        "<algorithm> <name>SURF</name>"
        "<option>"
        "<type>double</type> <name>thres</name> <value>15</value>"
        "</option>" "<option>"
        "<type>int</type> <name>Octaves</name> <value>3</value>"
        "</option>" "<option>"
        "<type>int</type> <name>Intervals</name> <value>4</value>"
        "</option>" "<option>"
        "<type>bool</type> <name>doubleImageSize</name> <value>false</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinDist</name> <value>3</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MinFraction</name> <value>0.0000001</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MaxPoints</name> <value>5000</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>Descriptorcreator</name> <value>None</value>"
        "</option>"

        "</algorithm>"
        "</command>"

        "<command> <name>FindLines</name>"
        "<option>"
        "<type>double</type> <name>MinLength</name> <value>15.0</value>"
        "</option>" "<option>"
        "<type>double</type> <name>MaxDist</name> <value>1.45</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FilterSize</name> <value>3</value>"
        "</option>"
        "</command>"

        "<command> <name>CalcDescriptors</name>"
        "<algorithm> <name>Sift</name>"
        "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>int</type> <name>DescriptorID</name> <value>0</value>"
        "</option>"
        "</algorithm>"
        "<algorithm> <name>SurfD</name>"
        "<option>"
        "<type>bool</type> <name>Upright</name> <value>false</value>"
        "</option>""<option>"
        "<type>int</type> <name>Subregions</name> <value>4</value>"
        "</option>" "<option>"
        "<type>bool</type> <name>SplitSums</name> <value>false</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>int</type> <name>DescriptorID</name> <value>0</value>"
        "</option>"
        "</algorithm>"
        "</command>"

        "<command> <name>CalcCorrs</name>"
        "<algorithm> <name>KDTree</name>"
        "<option>"
        "<type>enum</type> <name>Mode</name> <value>SingleBest</value>"
        "</option>" "<option>"
        "<type>double</type> <name>Distthresh</name> <value>1.0</value>"
        "</option>" "<option>"
        "<type>double</type> <name>GoodRatio</name> <value>0.7</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>" "<option>"
        "<type>int</type> <name>DescriptorID</name> <value>0</value>"
        "</option>"
        "</algorithm>"
        "<algorithm> <name>MatchLines</name>"
        "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>"
        "</algorithm>"
        "<algorithm> <name>Flann</name>"
        "<option>"
        "<type>double</type> <name>DistanceThreshold</name> <value>0.1</value>"
        "</option>"
        "<option>"
        "<type>int</type> <name>CountThreshold</name> <value>5000</value>"
        "</option>"
        "</algorithm>"
        "</command>"

        "<command> <name>Track</name>"
        "<algorithm> <name>KLTTracker</name>"
        "<option>"
        "<type>int</type> <name>MinDist</name> <value>10</value>"
        "</option>" "<option>"
        "<type>int</type> <name>WindowWidth</name> <value>7</value>"
        "</option>" "<option>"
        "<type>int</type> <name>WindowHeight</name> <value>7</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>SmoothBeforeSelecting</name> <value>Yes</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>LightingInsensitive</name> <value>No</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>ConsistencyCheck</name> <value>NoCheck</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MinValue</name> <value>100</value>"
        "</option>" "<option>"
        "<type>int</type> <name>MaxPoints</name> <value>1000</value>"
        "</option>" "<option>"
        "<type>int</type> <name>FeatureID</name> <value>0</value>"
        "</option>"
        "</algorithm>"
        "</command>"

        "<command> <name>Normalize</name> </command>"

        "<command> <name>Denormalize</name> </command>"

        "<command> <name>Filter</name>"
        "<option>"
        "<type>double</type> <name>Rancac2PixelError</name>"
        "<value>1.5</value>"
        "</option>"
        "<option>"
        "<type>enum</type> <name>Ransac2Error</name>"
        "<value>Standard</value>"
        "</option>"
        "<option>"
        "<type>enum</type> <name>Ransac2OptMethod</name>"
        "<value>INNER_RANSAC</value>"
        "</option>"
        "<option>"
        "<type>bool</type> <name>deleteOldNViews</name> <value>true</value>"
        "</option>"
        "<option>"
        "<type>double</type> <name>Rancac3PixelError</name>"
        "<value>10.0</value>"
        "</option>"
        "<option>"
        "<type>enum</type> <name>Ransac3Error</name>"
        "<value>Standard</value>"
        "</option>"
        "<option>"
        "<type>enum</type> <name>Ransac3OptMethod</name>"
        "<value>NONE</value>"
        "</option>"
        "</command>"

        "<command> <name>FilterAndMergeLines</name>"
        "<option>"
        "<type>double</type> <name>Threshold</name> <value>0.8</value>"
        "</option>"
        "</command>"

        "<command> <name>CalcTensor</name> </command>"

        "<command> <name>ProjectiveReconstruction</name> </command>"

        "<command> <name>MetricReconstruction</name>"
        "<option>"
        "<type>bool</type> <name>deleteMergedNViews</name> <value>true</value>"
        "</option>"
        "<option>"
        "<type>enum</type> <name>MergingType</name>"
        "<value>Standard</value>"
        "</option>"
        "<option>"
        "<type>enum</type> <name>FocalLegth</name> <value>SoftConst</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>AspectRatio</name> <value>SoftConst</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>Skew</name> <value>HardConst</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>PrincipalPointX</name> <value>SoftConst</value>"
        "</option>" "<option>"
        "<type>enum</type> <name>PrincipalPointY</name> <value>SoftConst</value>"
        "</option>" "<option>"
        "<type>double</type> <name>FL</name> <value>1.0</value> <value>3.0</value>"
        "</option>" "<option>"
        "<type>double</type> <name>AR</name> <value>1.0</value> <value>0.1</value>"
        "</option>" "<option>"
        "<type>double</type> <name>SKEW</name> <value>0.0</value> <value>0.001</value>"
        "</option>" "<option>"
        "<type>double</type> <name>PPX</name> <value>0.0</value> <value>0.1</value>"
        "</option>" "<option>"
        "<type>double</type> <name>PPY</name> <value>0.0</value> <value>0.1</value>"
        "</option>"
        "</command>"

        "<command> <name>DefaultReconstruction</name>"
        "<option>"
        "<type>double</type> <name>Thresh</name> <value>1.5</value>"
        "</option>" "<option>"
        "<type>bool</type> <name>Calibrate</name> <value>false</value>"
        "</option>" "<option>"
        "<type>int</type> <name>CalibrationTries</name> <value>1</value>"
        "</option>"
        "</command>"

        "<command> <name>GlobalAdjustment</name>"
        "<option>"
        "<type>int</type> <name>Number_of_initial_iterations</name> <value>16</value>"
        "</option>" "<option>"
        "<type>double</type> <name>Threshold_ratio</name> <value>0.8</value>"
        "</option>" "<option>"
        "<type>bool</type> <name>Use_2_Views_correspondences</name> <value>false</value>"
        "</option>"
        "</command>"
        ;

const char * const batch::get_init_string()
{
	return allinone;
}

const char * const allenums =
        "<enum> <name>Descriptorcreator</name>"
        "<enum_value>None</enum_value>"
        "<enum_value>Snap</enum_value>"
        "<enum_value>DiffColor</enum_value>"
        "<enum_value>Sift</enum_value>"
        "<enum_value>SurfD</enum_value>"
        "</enum>"

        "<enum> <name>Mode</name>"
        "<enum_value>SingleBest</enum_value>"
        "<enum_value>RatioBest</enum_value>"
        "<enum_value>BBFRatioBest</enum_value>"
        "</enum>"

        "<enum> <name>FocalLegth</name>"
        "<enum_value>Free</enum_value>" "<enum_value>FreeConst</enum_value>" "<enum_value>Soft</enum_value>"
        "<enum_value>SoftConst</enum_value>" "<enum_value>Hard</enum_value>" "<enum_value>HardConst</enum_value>"
        "</enum>"
        "<enum> <name>AspectRatio</name>"
        "<enum_value>Free</enum_value>" "<enum_value>FreeConst</enum_value>" "<enum_value>Soft</enum_value>"
        "<enum_value>SoftConst</enum_value>" "<enum_value>Hard</enum_value>" "<enum_value>HardConst</enum_value>"
        "</enum>"
        "<enum> <name>Skew</name>"
        "<enum_value>Free</enum_value>" "<enum_value>FreeConst</enum_value>" "<enum_value>Soft</enum_value>"
        "<enum_value>SoftConst</enum_value>" "<enum_value>Hard</enum_value>" "<enum_value>HardConst</enum_value>"
        "</enum>"
        "<enum> <name>PrincipalPointX</name>"
        "<enum_value>Free</enum_value>" "<enum_value>FreeConst</enum_value>" "<enum_value>Soft</enum_value>"
        "<enum_value>SoftConst</enum_value>" "<enum_value>Hard</enum_value>" "<enum_value>HardConst</enum_value>"
        "</enum>"
        "<enum> <name>PrincipalPointY</name>"
        "<enum_value>Free</enum_value>" "<enum_value>FreeConst</enum_value>" "<enum_value>Soft</enum_value>"
        "<enum_value>SoftConst</enum_value>" "<enum_value>Hard</enum_value>" "<enum_value>HardConst</enum_value>"
        "</enum>"
        "<enum> <name>SmoothBeforeSelecting</name>"
        "<enum_value>Yes</enum_value>" "<enum_value>No</enum_value>"
        "</enum>"
        "<enum> <name>LightingInsensitive</name>"
        "<enum_value>Yes</enum_value>" "<enum_value>No</enum_value>"
        "</enum>"

        "<enum> <name>ConsistencyCheck</name>"
        "<enum_value>NoCheck</enum_value>" "<enum_value>Translation</enum_value>"
        "<enum_value>Similarity</enum_value>" "<enum_value>Affine</enum_value>"
        "</enum>"

        "<enum> <name>Ransac2OptMethod</name>"
        "<enum_value>NONE</enum_value>"
        "<enum_value>ITERATIVE</enum_value>"
        "<enum_value>INNER_RANSAC</enum_value>"
        "</enum>"

        "<enum> <name>Ransac3OptMethod</name>"
        "<enum_value>NONE</enum_value>"
        "<enum_value>ITERATIVE</enum_value>"
        "<enum_value>INNER_RANSAC</enum_value>"
        "</enum>"

        "<enum> <name>Ransac2Error</name>"
        "<enum_value>Standard</enum_value>"
        "<enum_value>Sampson</enum_value>"
        "</enum>"

        "<enum> <name>Ransac3Error</name>"
        "<enum_value>Standard</enum_value>"
        "<enum_value>Sampson</enum_value>"
        "</enum>"

        "<enum> <name>MergingType</name>"
        "<enum_value>Standard</enum_value>"
        "<enum_value>Iterative</enum_value>"
        "</enum>"
        ;

const char * const batch::get_enum_string()
{
	return allenums;
}
