

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef CORRGL2D_H
#define CORRGL2D_H

#include <vector>
#include <boost/shared_ptr.hpp>

#include "item2d.h"

namespace adore
{
	namespace core
	{
		class PointCorr;
	}
}

class PixmapPlane;

class CorrGL2D : public Item2d
{
	public:
		typedef boost::shared_ptr<PixmapPlane> ImagePtr;
		CorrGL2D( adore::core::PointCorr* c, const std::vector<ImagePtr>& images );
		~CorrGL2D();

		void paint() const;
//		adore::core::PointCorr* pointCorr() const { return corr; }

	private:
		adore::core::PointCorr* corr;

		typedef boost::shared_ptr<Item2d> Child;
		std::vector<Child> children;
		void createContent( const std::vector<ImagePtr>& images );
};

#endif
