

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef DIRTREEWIDGET_H
#define DIRTREEWIDGET_H

#include <QTreeView>

#include "dirmodel.h"

class DirTreeWidget : public QTreeView
{
	Q_OBJECT
public:
	DirTreeWidget( QWidget* parent, DirModel::Mode mode = DirModel::Files );

	void setFilters( const QStringList& filters );
	void cd( const QString& path );
	QString currentSelection() const;

signals:
	void signalFileActivated( const QString& path ) const;
	void signalDirActivated( const QString& path ) const;

private:
	DirModel model;

private slots:
	void slotItemActivated( const QModelIndex& index ) const;
	void slotRefreshRoot();
};

#endif // DIRTREEWIDGET_H
