

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "errorwidget.h"

#include <QGraphicsView>
#include <QGraphicsScene>
#include <QGraphicsRectItem>

ErrorWidget::ErrorWidget( const QString& title, QWidget* parent )
		: QWidget( parent )
{
	ui.setupUi( this );
	ui.what->setText( title );

	QSizePolicy p( QSizePolicy::Expanding, QSizePolicy::Expanding );
	QBoxLayout* layout = new QVBoxLayout;
	grscene = new QGraphicsScene( 0, 0, 200, 30 );
	grview = new QGraphicsView( grscene );
	grview->setSizePolicy( p );
	layout->addWidget( grview );
	ui.dist->setLayout( layout );
}

ErrorWidget::~ErrorWidget() {}

void ErrorWidget::drawErrors( vector<double> &err )
{
	const int rw = 1;//half width of rect
	const int rh = 4;//half height of rect
	double delta = grscene->width() / ( maxErr - minErr );
	int yOff = ( int )grscene->height() >> 1;
	QColor color = Qt::white;
	for ( uint i = 0; i < err.size(); ++i )
	{
		int pos = int( delta * ( err[i] - minErr ) );
		QGraphicsRectItem* rect = new QGraphicsRectItem( pos - rw, yOff - rh, rw + rw, rh + rh );
		rect->setBrush( QBrush( color ) );
		grscene->addItem( rect );
	}
}
