

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef GROUPBOXGL_H
#define GROUPBOXGL_H

#include <vector>

class QGLWidget;

#include "controlgl.h"

class GroupBoxGL : public ControlGL
{
public:
    GroupBoxGL();
	~GroupBoxGL();

	void initialize(QGLWidget* binder);
	void cleanup();

	void paint() const;

	void addControl(ControlGL * control);

	virtual void pressed(double x, double y);
	virtual void released(double x, double y);
	virtual void moved(double x, double y);

protected:
	void click(double, double) {}
	void beginDragging(double, double) {}
	void drag(double, double) {}

private:
	typedef std::vector<ControlGL*> ContentT;
	ContentT m_content;
	ControlGL * m_focused;

	double getMaxWidth() const;
};

#endif // GROUPBOXGL_H
