

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef INSPECTOR_H
#define INSPECTOR_H

#include <QDialog>

#include <adrcore/types/nview.h>
#include <adrcore/parameterization/angleaxis.h>
using namespace adore::core;

#include "camerawidget.h"
#include "errorwidget.h"

#include <vector>
using namespace std;

#include "ui_nviewinspector.h"

class NViewStatistics;

class Inspector : public QDialog
{
		Q_OBJECT

	public:
		Inspector( NView* nv, QWidget* parent = 0 );
		~Inspector();

	public slots:
		virtual void recalc();
		virtual void maximizeHor();

	private:
		NView *nview;
		QWidget *cameraTab;
		QWidget *errorTab;
		QWidget* cameraPanel;
		QWidget* errorPanel;
		NViewStatistics* nviewStatistics;

		vector<CameraWidget *> cw;
		vector<ErrorWidget *> ew;
		AngleAxis anax;

		void fillCamViews();
		void fillErrorViews();
		void fillStatistics();

		Ui::NViewInspector ui;
};

#endif

