

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef OBJECTSELECTSAVEDIALOG_H
#define OBJECTSELECTSAVEDIALOG_H

#include <string>
#include <vector>

#include "ui_objectselectsave.h"

class ObjectSelectSaveDialog : public QDialog
{
		Q_OBJECT

	public:
		ObjectSelectSaveDialog()
		{
			ui.setupUi( this );
			ui.listBox->setSelectionMode( QAbstractItemView::SingleSelection );
		};

		void setNames( std::vector<std::string> names )
		{
			std::vector<std::string>::iterator myit=names.begin();
			for ( ; myit != names.end(); ++myit )
				ui.listBox->addItem( QString::fromStdString( *myit ) );
			if ( ui.listBox->count() )
				ui.listBox->item( 0 )->setSelected( true );
		}
		void unselect() { ui.listBox->clearSelection(); }
		std::string getSelected()
		{
			if ( ui.listBox->selectionModel()->hasSelection() )
				return ui.listBox->currentItem()->text().toStdString();
			return std::string();
		}
		std::string getLineEdit()
		{
			return ui.lineEdit->text().toStdString();
		}
	private:
		Ui::ObjectSelectSave ui;
};


#endif
