

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef PROGRESS_DIALOG_H
#define PROGRESS_DIALOG_H

#include <QDialog>

class QProgressBar;
class QTextBrowser;

class CalcThread;
class QTimer;

class ProgressDialog : public QDialog
{
		Q_OBJECT
	private:
		CalcThread* thread;

		QProgressBar* progressBar;
		QTextBrowser* log;

		//animation
		QTimer *timer;
		int aniPhase;
		float aniPos;

	public:
		ProgressDialog( CalcThread* thr, QWidget* parent, bool show_list );

	private slots:
		void slotAbortAfterNext();
		void slotThreadOpBegin();
		void slotThreadOpEnd();
		void timetick();

	private:
		void appendText( const QString& text );

		void closeEvent( QCloseEvent* event );
};

#endif
