

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef SELECTOR_H
#define SELECTOR_H

#include <QStandardItemModel>

#include "ui_selector.h"

class ComboDelegate;

class Selector : public QWidget, private Ui::Selector
{
		Q_OBJECT
	public:
		Selector( QWidget* parent = 0 );
		Selector( const QString& fname, QWidget* parent = 0 );
		~Selector();

		QString makeScript()const;

		/**
			loads a config file, but does not remember
			its path. This is archieved only by using
			slotOpen.
		*/
		void load( const QString& fname );

	private slots:
		void slotNew();
		void slotAdd( QAction* action );
		void slotRemove();
		void slotUp();
		void slotDown();
		void slotOpen();
		void slotSave();
		void slotSyncToCombo( int idx );
		void slotEditOptions( const QModelIndex& index );

	signals:
		void sigStart( QString );
	private:
		enum { item_opts_idx = Qt::UserRole };
		void init();
		void makeConnections();

		QVector<QString> commands;
		QMenu* commandMenu;

		QStandardItemModel model;
		ComboDelegate* combo;
		QStandardItem* fillAlgItem( const std::string& cmd )const;
		QStandardItem* fillOptItem( const std::string& cmd )const;

		QString lastDir;
};

#endif
