

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef TEXTLABELGL_H
#define TEXTLABELGL_H

#include <QtCore/QString>

#include <GL/gl.h>

class QGLWidget;

class TextLabelGL
{
public:
	TextLabelGL(const QString& txt);

	void buildTexture(uint foregroundArgb, QGLWidget* binder);
	void releaseTexture();

	int width() const { return m_width; }
	int height() const { return m_height; }

	void draw() const;

private:
	QString m_text;
	GLuint m_texture;
	int m_width, m_height;
};

#endif // TEXTLABELGL_H
